' This code can be incorporated into your application as
' long as the copyright notice is left intact.
' Redistribution of Azalea Software's fonts requires a licensing fee.

' Input error checking is the calling application's responsibility.

'*************************************************************************************


Function Padding(Str, Length) ' Pad the Length of the Dx Codes to 6
	' If the length of the Str is less than the variable 'length'
	If Len(Str) < Length Then
		padding = ""
		howmanyspaces = Length - len(Str)
		for i = 1 to (howmanyspaces)
			padding = padding & "0"
		next
		mystring = padding & Str
		' If the length of the Str is greater than the variable 'length'
		Elseif len(Str) > Length Then
		mystring = Left(Str,Length)
	Else
		mystring = Str
	End If
	Padding = mystring
End Function



Public Function AzaleaI2of5(I2of5number)

If Not IsNumeric(I2of5number) Then Exit Function
AzaleaI2of5 = PAzaleaI2of5(I2of5number)

End Function

'*************************************************************************************

Private Function PAzaleaI2of5(I2of5number)
' I2of5Tools v5.5
' Copyright 2003 Jerry Whiting.  All rights reserved.
' Azalea Software, Inc.   info@azalea.com   1 206 341.9500

  ' The input, I2of5number, is a numbers-only string.
  ' Format the output, AzaleaI2of5, using Azalea Software, Inc.'s bar code fonts.
  
  Dim i 
  Dim temp 
  Dim temp2   ' placeholder
  Dim chunk   ' placeholder
  
  If Len(I2of5number) Mod 2 <> 0 Then     ' if input has an odd number of digits
    I2of5number = "0" + I2of5number          ' ...so pad it with a leading zero
  End If

  ' divide input into pairs of digits
 temp2 = I2of5number
  
 For i = 1 To Len(I2of5number) / 2
    
    chunk = Left(temp2, 2)          'let's consider 2 first characters
	
   'PAzaleaI2of5 = chunk
   'If i = 1 Then
   'Exit Function
   'End If
        If Left(chunk,1) = "0" Then
			chunk = Mid(chunk,2,1)
			'PAzaleaI2of5 = chunk
			'Exit Function
		End If
		If CInt(chunk) < 90 Then
      
            temp = temp + Chr(CInt(chunk) + 33)
    
        ElseIf CInt(chunk) = 90 Or CInt(chunk) = 91 Then
      
             temp = temp + Chr(CInt(chunk) + 92)
      
        Else
      
            temp = temp + Chr(CInt(chunk) + 104)
    
        End If
    
      temp2 = Right(temp2, Len(temp2) - 2)     'then we erase the 2 first characters and....
  
  Next 

  ' add start and stop bars (ASCII 171 & ASCII 172)
 
 PAzaleaI2of5 = Chr(171) + temp + Chr(172)
 'PAzaleaI2of5 = Chr(171) + "s>H'I#" + Chr(172)
  
End Function

Public Function I2of5WithLuhn(I2of5number)
' I2of5Tools v5.5
' Copyright 2003 Jerry Whiting.  All rights reserved.
' Azalea Software, Inc.   info@azalea.com   1 206 341.9500

  ' The input, I2of5number, is a numbers-only string.
  ' Format the output, AzaleaI2of5, using Azalea Software, Inc.'s bar code fonts.
  I2of5number = Padding(I2of5number,11)
  'msgBox(I2of5number)
  Dim i 
  Dim temp 
  Dim checkDigit
  Dim temp2   ' placeholder
  Dim chunk   ' placeholder
  
  'If Len(I2of5number) Mod 2 <> 0 Then     ' if input has an even number of digits
  '  I2of5number = "0" + I2of5number          ' ...so pad it with a leading zero
  'End If
  checkDigit = 3 * (CInt(Mid(I2of5number, 1, 1)) + CInt(Mid(I2of5number, 3, 1)) + _
                    CInt(Mid(I2of5number, 5, 1)) + CInt(Mid(I2of5number, 7, 1)) + _
                    CInt(Mid(I2of5number, 9, 1)) + CInt(Mid(I2of5number, 11, 1)))
  checkDigit = checkDigit + CInt(Mid(I2of5number, 2, 1)) + CInt(Mid(I2of5number, 4, 1)) + _
                            CInt(Mid(I2of5number, 6, 1)) + CInt(Mid(I2of5number, 8, 1)) + _
                            CInt(Mid(I2of5number, 10, 1))

							checkDigit = 10 - checkDigit Mod 10
  
  If checkDigit = 10 Then checkDigit = 0
  I2of5number =  I2of5number & checkDigit
 ' divide input into pairs of digits
  temp2 = I2of5number
  
 For i = 1 To Len(I2of5number) / 2
    
    chunk = Left(temp2, 2)          'let's consider 2 first characters
	
   'PAzaleaI2of5 = chunk
   'If i = 1 Then
   'Exit Function
   'End If
        If Left(chunk,1) = "0" Then
			chunk = Mid(chunk,2,1)
			'PAzaleaI2of5 = chunk
			'Exit Function
		End If
		If CInt(chunk) < 90 Then
      
            temp = temp + Chr(CInt(chunk) + 33)
    
        ElseIf CInt(chunk) = 90 Or CInt(chunk) = 91 Then
      
             temp = temp + Chr(CInt(chunk) + 92)
      
        Else
      
            temp = temp + Chr(CInt(chunk) + 104)
    
        End If
    
      temp2 = Right(temp2, Len(temp2) - 2)     'then we erase the 2 first characters and....
  
  Next 
  
  ' add start and stop bars (ASCII 171 & ASCII 172)
 
 I2of5WithLuhn = Chr(171) + temp + Chr(172)
  
End Function

Function LuhnCheck(strNumber)
	' Use a quick regular expression to remove any non-digit characters
	Set RegEx = New RegExp
	RegEx.Global = True
	RegEx.Pattern = "[\D\s]+"
	strNumber = RegEx.Replace(strNumber, "")
	Set RegEx = Nothing
 
	' Grab the length of the string of numbers
	intLength = Len(strNumber)
	' Grab the parity (Whether the first digit in an even or odd position
	'   within the string)
	intParity = intLength Mod 2
 
	' Loop across each digit in the number string
	For i = 1 To intLength
		' Mid is used to grab a single digit
		intDigit = CInt(Mid(strNumber, i, 1))
		' Parity is used to determine every other digit from the right
		If i Mod 2 <> intParity Then
			' Double every other digit
			intDigit = intDigit * 2
			' if that value is two digits...(greater than 9)
			If intDigit > 9 Then
				'...add the digits together (same as subtracting 9)
				'  e.g.  consider 12.  1+2=3 or 12-9=3
				intDigit = intDigit - 9
			End If
		End If
		intSum = intSum + intDigit
	Next
'MsgBox(intSum)
	' True if number is evenly divisble by 10, false otherwise
	LuhnCheck = (intSum Mod 10)
End Function
'*************************************************************************************
' This code can be incorporated into your application as
' long as the copyright notice is left intact.
' Redistribution of Azalea Software's fonts requires a licensing fee.

' Input error checking is the calling application's responsibility.

Public Function AzaleaI2of5SCCF(ByVal SCCF ) 
	If Len(SCCF) <> 13 Then
		SCCF = Padding(SCCF,13)
	End If
If Not IsNumeric(SCCF) Or Len(SCCF) < 11 Then Exit Function
 
AzaleaI2of5SCCF = CStr(PAzaleaI2of5SCCF(SCCF))

End Function
 
'*************************************************************************************

Private Function PAzaleaI2of5SCCF(SCCF ) 
' I2of5Tools v5.0
' Copyright 2002 Jerry Whiting.  All rights reserved.
' Azalea Software, Inc.   info@azalea.com   1 206 341.9500

' The input, I2of5number, a 13-digit digit number.
' Format the output, AzaleaI2of5SCCF, using Azalea Software, Inc.'s bar code fonts.
  
  Dim checkDigit           ' check digit itself
  Dim temp                 ' placeholder
  Dim chunk                ' placeholder
  Dim temp2 

  ' do the UPC check digit over all 13 digits
  checkDigit = 3 * (CInt(Mid(SCCF, 1, 1)) + CInt(Mid(SCCF, 3, 1)) + _
                   CInt(Mid(SCCF, 5, 1)) + CInt(Mid(SCCF, 7, 1)) + _
                  CInt(Mid(SCCF, 9, 1)) + CInt(Mid(SCCF, 11, 1)) + CInt(Mid(SCCF, 13, 1)))
  
  checkDigit = checkDigit + CInt(Mid(SCCF, 2, 1)) + CInt(Mid(SCCF, 4, 1)) + _
                            CInt(Mid(SCCF, 6, 1)) + CInt(Mid(SCCF, 8, 1)) + _
                            CInt(Mid(SCCF, 10, 1)) + CInt(Mid(SCCF, 12, 1))
  
  checkDigit = 10 - checkDigit Mod 10
  
  If checkDigit = 10 Then checkDigit = 0
  'checkDigit = LuhnCheck(SCCF)
  'MsgBox(checkDigit)
  
  SCCF = SCCF & checkDigit ' now SCCF is a 14 (even) digit number

  ' divide it into pairs
  
  temp = SCCF
  
  For i = 1 To Len(SCCF) / 2
    
    chunk = Left(temp, 2)
    
    If CInt(chunk) < 90 Then
    
      temp2 = temp2 + Chr(CInt(chunk) + 33)
      
    ElseIf CInt(chunk) = 90 Or CInt(chunk) = 91 Then
    
      temp2 = temp2 + Chr(CInt(chunk) + 92)
      
    Else
    
      temp2 = temp2 + Chr(CInt(chunk) + 104)
      
    End If
      
      temp = Right(temp, Len(temp) - 2)
  
  Next 

  ' add start and stop bars (ASCII 171 & ASCII 172)
  PAzaleaI2of5SCCF = Chr(171) + temp2 + Chr(172)

  ' Format the output, AzaleaI2of5SCCF, using Azalea Software, Inc.'s bar code fonts.
  
End Function

'dim test
'test = I2of5WithLuhn(82293906400)
'MsgBox(test)